# ISystemProperties Interface Reference

The ISystemProperties interface represents global properties of the given VirtualBox installation. More...

List of all members.

## Public Attributes
readonly attribute unsigned long | minGuestRAM
| Minium guest system memory in Megabytes.
readonly attribute unsigned long | maxGuestRAM
| Maximum guest system memory in Megabytes.
readonly attribute unsigned long | minGuestVRAM
| Minimum guest video memory in Megabytes.
readonly attribute unsigned long | maxGuestVRAM
| Maximum guest video memory in Megabytes.
readonly attribute unsigned long long | maxVDISize
| Maximum size of a virtual disk image in Megabytes.
readonly attribute unsigned long | networkAdapterCount
| Number of network adapters associated with every IMachine instance.
readonly attribute unsigned long | serialPortCount
| Number of serial ports associated with every IMachine instance.
readonly attribute unsigned long | parallelPortCount
| Number of parallel ports associated with every IMachine instance.
readonly attribute unsigned long | maxBootPosition
| Maximum device position in the boot order.
attribute wstring | defaultVDIFolder
| Full path to the default directory used to create new or open existing virtual disk images when an image file name contains no path.
attribute wstring | defaultMachineFolder
| Full path to the default directory used to create new or open existing machines when a settings file name contains no path.
attribute wstring | remoteDisplayAuthLibrary
| Library that provides authentication for VRDP clients.
attribute wstring | webServiceAuthLibrary
| Library that provides authentication for webservice clients.
attribute boolean | HWVirtExEnabled
| This specifies the default value for hardware virtualization extensions.
attribute unsigned long | LogHistoryCount
| This value specifies how many old release log files are kept.

## Detailed Description

The ISystemProperties interface represents global properties of the given VirtualBox installation.

These properties define limits and default values for various attributes and parameters. Most of the properties are read-only, but some can be changed by a user.

Interface ID:
  `{12C2E31E-247F-4D51-82E5-5B9D4A6C7D5B}`

## Member Data Documentation

readonly attribute unsigned long ISystemProperties::minGuestRAM

Minium guest system memory in Megabytes.

readonly attribute unsigned long ISystemProperties::maxGuestRAM

Maximum guest system memory in Megabytes.

readonly attribute unsigned long ISystemProperties::minGuestVRAM

Minimum guest video memory in Megabytes.

readonly attribute unsigned long ISystemProperties::maxGuestVRAM

Maximum guest video memory in Megabytes.

readonly attribute unsigned long long ISystemProperties::maxVDISize

Maximum size of a virtual disk image in Megabytes.

readonly attribute unsigned long ISystemProperties::networkAdapterCount

Number of network adapters associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::serialPortCount

Number of serial ports associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::parallelPortCount

Number of parallel ports associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::maxBootPosition

Maximum device position in the boot order.

This value corresponds to the total number of devices a machine can boot from, to make it possible to include all possible devices to the boot list.

See also:
  IMachine::setBootOrder()

attribute wstring ISystemProperties::defaultVDIFolder

Full path to the default directory used to create new or open existing virtual disk images when an image file name contains no path.

The initial value of this property is `<`VirtualBox_home`>/VDI`.

Note:
  Setting this property to `null` will restore the initial value.

  When settings this property, the specified path can be absolute (full path) or relative to the VirtualBox home directory. When reading this property, a full path is always returned.

  The specified path may not exist, it will be created when necessary.

See also:
  IVirtualBox::createHardDisk(), IVirtualBox::openVirtualDiskImage()

attribute wstring ISystemProperties::defaultMachineFolder

Full path to the default directory used to create new or open existing machines when a settings file name contains no path.

The initial value of this property is `<`VirtualBox_home`>/Machines`.

Note:
  Setting this property to `null` will restore the initial value.

  When settings this property, the specified path can be absolute (full path) or relative to the VirtualBox home directory. When reading this property, a full path is always returned.

  The specified path may not exist, it will be created when necessary.

See also:
  IVirtualBox::createMachine(), IVirtualBox::openMachine()

attribute wstring ISystemProperties::remoteDisplayAuthLibrary

Library that provides authentication for VRDP clients.

The library is used if a virtual machine's authentication type is set to "external" in the VM RemoteDisplay configuration.

The system library extension (".DLL" or ".so") must be omitted. A full path can be specified; if not, then the library must reside on the system's default library path.

The default value of this property is `VRDPAuth`. There is a library of that name in one of the default VirtualBox library directories.

For details about VirtualBox authentication libraries and how to implement them, please refer to the VirtualBox manual.

Note:
  Setting this property to `null` will restore the initial value.

attribute wstring ISystemProperties::webServiceAuthLibrary

Library that provides authentication for webservice clients.

The library is used if a virtual machine's authentication type is set to "external" in the VM RemoteDisplay configuration and will be called from within the IWebsessionManager::logon implementation.

As opposed to ISystemProperties::remoteDisplayAuthLibrary, there is no per-VM setting for this, as the webservice is a global resource (if it is running). Only for this setting (for the webservice), setting this value to a literal "null" string disables authentication, meaning that IWebsessionManager::logon will always succeed, no matter what user name and password are supplied.

The initial value of this property is `VRDPAuth`, meaning that the webservice will use the same authentication library that is used by default for VBoxVRDP (again, see ISystemProperties::remoteDisplayAuthLibrary). The format and calling convetion of authentication libraries is the same for the webservice as it is for VBoxVRDP.

attribute boolean ISystemProperties::HWVirtExEnabled

This specifies the default value for hardware virtualization extensions.

If enabled, virtual machines will make use of hardware virtualization extensions such as Intel VT-x and AMD-V by default. This value can be overridden by each VM using their IMachine::HWVirtExEnabled property.

attribute unsigned long ISystemProperties::LogHistoryCount

This value specifies how many old release log files are kept.